// STAGE::Sylvanus::tree.cpp
// Copyright (C) 2001 Jari Sundell and The WorldForge Project
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
//  For information about Worldforge and its authors, please contact
//  the Worldforge Web Site at http://www.worldforge.org.

// Author: Jari Sundell (Rakshasa)
// Created: 2001-09-07 by Jari Sundell

class Bounds2D {};

template<class Shape> class Stump;

class Stump<Bounds2D> {
 public:

  // This class originally from a header, the constant is initialized
  // in a different .cpp file
  const static int m_numBranches;
};

template<class Shape>
class TreeImpl : private Stump<Shape> {

 protected:
  int getBranchNumber(TreeImpl<Shape> *t);

 private:

  // First works fine, second gives compiler error
  TreeImpl<Shape> **m_branch;
  // TreeImpl<Shape> *m_branch[m_numBranches];
};

int TreeImpl<Bounds2D>::getBranchNumber(TreeImpl<Bounds2D> *t) {return -1;}
